﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Player_script : MonoBehaviour {

	ChuckSubInstance myChuck;

	public float maxSpeed = 4f;
	public float speed = 50f;
	public float jumpPower = 350f;
	public string sword_pitch = "C";
	public string sword_freq = "262";
	public GameObject spell = null;
	public GameObject shockwave = null;
	public GameObject shocker = null;
	public bool grounded;
	public bool canDblJump;
	public bool attacking;
	private int health = 30;
	public int max_health = 30;
	public int score = 0;
	public Text lose_text;
	public Text score_text;
	public Text pitch_text;
	public bool lost = false;
	public Slider HealthBar;
	public Vector2 spell_pos;

	private Dictionary<string, string> name2freq = new Dictionary<string, string>()
	{
		{"A", "440"},
		{"B", "494"},
		{"C", "262"},
		{"D", "294"},
		{"E", "330"},
		{"F", "349"},
		{"G", "392"}
	};
	private Rigidbody2D rb2d;
	private Animator anim;
	private Spawner spawner;
	private SpriteRenderer rend;
	private bool shocked = false;


	// Use this for initialization
	void Start () {
		myChuck = GetComponent<ChuckSubInstance>();
		rb2d = gameObject.GetComponent<Rigidbody2D> ();
		anim = gameObject.GetComponent<Animator> ();
		rend = GetComponent<SpriteRenderer>();
		attacking = false;
		health = max_health;
		set_life_text ();
		lose_text.text = "";
	}
	
	// Update is called once per frame
	void Update () {
		set_life_text ();
		anim.SetBool ("ground", grounded);
		anim.SetBool ("attacking", attacking);
		anim.SetFloat ("speed", Mathf.Abs(rb2d.velocity.x));
		if (Input.GetAxis ("Horizontal") > 0.1f) {
			transform.localScale = new Vector3 (1,1,1);
		}else if (Input.GetAxis ("Horizontal") < -0.1f) {
			transform.localScale = new Vector3 (-1,1,1);
		}
		if (Input.GetKeyDown (KeyCode.UpArrow)) {
			if (grounded) {
				rb2d.AddForce (Vector2.up * jumpPower);
				canDblJump = true;
			} else if (canDblJump) {
				rb2d.AddForce (Vector2.up * jumpPower);
				rb2d.velocity = new Vector2 (rb2d.velocity.x, 0);
				canDblJump = false;
			}
		}
		if (Input.GetKeyDown (KeyCode.Space)) {
			attacking = true;
		}
		if (Input.GetKeyDown(KeyCode.A)) {
			sword_pitch = "A";
			sword_freq = name2freq[sword_pitch];
		} else if (Input.GetKeyDown(KeyCode.B)) {
			sword_pitch = "B";
			sword_freq = name2freq[sword_pitch];
		} else if (Input.GetKeyDown(KeyCode.C)) {
			sword_pitch = "C";
			sword_freq = name2freq[sword_pitch];
		} else if (Input.GetKeyDown(KeyCode.D)) {
			sword_pitch = "D";
			sword_freq = name2freq[sword_pitch];
		} else if (Input.GetKeyDown(KeyCode.E)) {
			sword_pitch = "E";
			sword_freq = name2freq[sword_pitch];
		} else if (Input.GetKeyDown(KeyCode.F)) {
			sword_pitch = "F";
			sword_freq = name2freq[sword_pitch];
		} else if (Input.GetKeyDown(KeyCode.G)) {
			sword_pitch = "G";
			sword_freq = name2freq[sword_pitch];
		}
	}

	void FixedUpdate() {
		float h = Input.GetAxis ("Horizontal");
		rb2d.AddForce ((Vector2.right*speed)*h);
		if (rb2d.velocity.x > maxSpeed) {
			rb2d.velocity = new Vector2 (maxSpeed, rb2d.velocity.y);
		}else if (rb2d.velocity.x < -maxSpeed) {
			rb2d.velocity = new Vector2 (-maxSpeed, rb2d.velocity.y);
		}
	}

	void OnTriggerEnter2D(Collider2D col){
		if (col.gameObject.tag == "enemies" && !shocked) {
			health -= 4;
			shocked = true;
			StartCoroutine(damageFlash());
		}else if (col.gameObject.tag == "projectiles" && !shocked) {
			health -= 4;
			Destroy (col.gameObject);
			shocked = true;
			StartCoroutine(damageFlash());
		}
		if (health < 0) {
			health = 0;
		}
	}

	void set_life_text ()
	{
		HealthBar.value = (float)health / max_health;
		score_text.text = score.ToString ();
		pitch_text.text = sword_pitch;
		if (health <= 0 && !lost)
		{
			lost = true;
			lose_text.text = "Nice try! Final score: " + score.ToString ();
		}
	}

	void attack_start (int ms2next)
	{
		spell_pos = transform.position;
		Instantiate (spell, transform.position, Quaternion.identity);
		myChuck.RunCode( @"
			external int MillSecs1;
			external int MillSecs2;
			external Event Bang1;
			external Event Bang2;
			external Event Bang3;
			TriOsc myOsc => Envelope e => dac;
			SinOsc Ring => ADSR a => dac;
			SawOsc Zing => a;
			" + sword_freq + @" => myOsc.freq;
			" + sword_freq + @"*2.0 => Ring.freq;
			" + sword_freq + @" => Zing.freq;
			0.1 => myOsc.gain;
			0.7 => Ring.gain;
			0.05 => Zing.gain;
			" + ms2next + @"::ms => e.duration;
			e.keyOn();
			Bang1 => now;
			a.set( (MillSecs1/6.0)::ms, ((MillSecs1*5.0)/6.0)::ms, .25, 0.1::ms );
			a.keyOn();
			Bang2 => now;
			MillSecs2::ms => a.releaseTime;
			MillSecs2::ms => e.duration;
			a.keyOff();
			e.keyOff();
			Bang3 => now;
			" );
	}

	void attack_mid (int ms2next)
	{
		GetComponent<ChuckSubInstance> ().SetInt ("MillSecs1", ms2next);
		GetComponent<ChuckSubInstance> ().BroadcastEvent ("Bang1");
		transform.root.BroadcastMessage ("resonate", sword_pitch);
		Instantiate (shockwave, spell_pos, Quaternion.identity);
	}

	void attack_end (int ms2next)
	{
		GetComponent<ChuckSubInstance> ().SetInt ("MillSecs2", ms2next);
		GetComponent<ChuckSubInstance> ().BroadcastEvent ("Bang2");
	}

	void attack_tail ()
	{
		GetComponent<ChuckSubInstance> ().BroadcastEvent ("Bang3");
		attacking = false;
	}
		
	IEnumerator damageFlash () {
		GameObject shock = GameObject.Instantiate (shocker, transform.position, Quaternion.identity, transform) as GameObject;
		float ft = 0.1f;
		rend.material.color = new Color(0f,1f,1f,1f);
		myChuck.RunCode( @"
			Noise n => ADSR e => HPF h => dac;
			1000.0 => h.freq;
			e.set(2::ms, 10::ms, 0.5, 2::ms);
			.1 => n.gain;
			e.keyOn();
		    " + ft.ToString() + @"*1000::ms => now;
		    e.keyOff();
			3::ms => now;;
			" );
		yield return new WaitForSeconds(ft);
		rend.material.color = new Color(1f,1f,1f,1f);
		yield return new WaitForSeconds(ft);
		rend.material.color = new Color(0f,1f,1f,1f);
		myChuck.RunCode( @"
			Noise n => ADSR e => LPF l => dac;
			1000.0 => l.freq;
			e.set(2::ms, 10::ms, 0.5, 2::ms);
			.2 => n.gain;
			e.keyOn();
		    " + ft.ToString() + @"*1000::ms => now;
		    e.keyOff();
			3::ms => now;;
			" );
		yield return new WaitForSeconds(ft);
		rend.material.color = new Color(1f,1f,1f,1f);
		Destroy(shock);
		yield return new WaitForSeconds(ft);
		shocked = false;
	}
}
