﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Spawner : MonoBehaviour {

	public float[] y_range = new float[] { -4f, 5f };
	public float[] x_range = new float[] { -8f, 8f };
	public GameObject enemy = null;
	public float wait_in_sec = 3.5f;
	public int concurrent_max = 3;
	public int concurrent_count = 0;
	public bool in_empty_space = true;
	public Player_script player;

	private float next_time = 0.0f;

	// Use this for initialization
	void Start () {
		
	}
	
	// Update is called once per frame
	void Update () {
		if (Time.time > next_time) {
			if (!in_empty_space) {
				randomize_position ();
				wait_in_sec = 0.5f;
			} else {
				Vector2 player_position = player.transform.position;
				Vector2 my_position = new Vector2 (transform.position.x, transform.position.y);
				float the_distance = Vector2.Distance (player_position, my_position);
				if (concurrent_count < concurrent_max && the_distance > 4.0f) {
					concurrent_count++;
					Instantiate (enemy, transform.position, Quaternion.identity, transform.root.transform);
				}
				wait_in_sec = 3.5f;
			}
			next_time = Time.time + wait_in_sec;
		}
	}

	void randomize_position () {
		float x = Random.Range (x_range [0], x_range [1]);
		float y = Random.Range (y_range [0], y_range [1]);
		Vector3 new_pos = new Vector3 (x, y, transform.position.z);
		transform.position = new_pos;
	}

	void OnTriggerEnter2D(Collider2D col){
		if (col.gameObject.tag != "projectiles") {
			in_empty_space = false;
		}
	}

	void OnTriggerStay2D(Collider2D col){
		if (col.gameObject.tag != "projectiles") {
			in_empty_space = false;
		}
	}

	void OnTriggerExit2D(Collider2D col){
		if (col.gameObject.tag != "projectiles") {
			in_empty_space = true;
		}
	}
}
